import * as acm from '@aws-cdk/aws-certificatemanager';
import * as cloudfront from '@aws-cdk/aws-cloudfront';
import * as s3 from '@aws-cdk/aws-s3';
import * as s3Deploy from '@aws-cdk/aws-s3-deployment';
import * as cdk from '@aws-cdk/core';
export interface VueDeploymentProps {
    readonly source: string;
    readonly bucket?: s3.Bucket;
    readonly bucketName?: string;
    readonly websiteDirectoryPrefix?: string;
    readonly memoryLimit?: number;
    readonly prune?: boolean;
    readonly retainOnDelete?: boolean;
    readonly enableDistribution?: boolean;
    readonly distribution?: cloudfront.Distribution;
    readonly certificate?: acm.ICertificate;
    readonly domainNames?: string[];
    readonly indexHtml?: string;
    readonly distributionComment?: string;
    readonly enableIpv6?: boolean;
    readonly environment?: {
        [key: string]: string;
    };
    readonly bundlingArguments?: string;
    readonly runsLocally?: boolean;
    readonly forceDockerBundling?: boolean;
    readonly nodeImage?: string | 'public.ecr.aws/bitnami/node';
    readonly configJsKey?: string;
    readonly config?: {
        [key: string]: any;
    };
}
export declare class VueDeployment extends cdk.Construct {
    readonly bucket: s3.Bucket;
    readonly bucketDeployment: s3Deploy.BucketDeployment;
    readonly cloudfrontDistribution: cloudfront.Distribution;
    readonly uploadConfigResource: cdk.CustomResource;
    private readonly websiteDirectoryPrefix;
    constructor(scope: cdk.Construct, id: string, props: VueDeploymentProps);
    private createOrGetBucket;
    private createBucketDeployment;
    private createUploadConfigResource;
    private createCloudfrontDistribution;
}
